/***************************************************************************
                          FBlib.h  -  description
                             -------------------
    begin                : Mon Nov 20 2000
    copyright            : (C) 2000 by Daniele Venzano
    email                : venza@iol.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License.               *
 *                                                                         *
 ***************************************************************************/
#ifndef FBLIB_H
#define FBLIB_H

#include <sys/ioctl.h>
#include <stdio.h>
#include <stdlib.h>
#include <linux/fb.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <sys/mman.h>
#include <string.h>
#include <linux/kd.h>
#include <signal.h>
#include <linux/vt.h>

#define DEBUG 1
#define u_char unsigned char
#define IOCTL_ERR -2
#define MMAP_ERR -3

typedef __u32 FB_pixel;
extern int FB_visible; /* User is on the same VT as FBlib program */

int FB_initlib(const char *dev);  /* dev is the framebuffer device name (eg. "/dev/fb0") */
int FB_exit();   /* You must call this at the end of your program to free up memory and reset framebuffer*/

FB_pixel FB_makecol(u_char r,u_char g, u_char b, u_char t);
int FB_clear_screen(FB_pixel color);
int FB_putpixel(int x, int y, FB_pixel color);
FB_pixel FB_getpixel(int x, int y);
int FB_vline(int x, int sy, int ey, FB_pixel color);
int FB_hline(int sx, int ex, int y, FB_pixel color);
int FB_line(int sx, int sy, int ex, int ey, FB_pixel color);
int FB_rect(int sx, int sy, int ex, int ey, FB_pixel color);
int FB_rectfill(int sx, int sy, int ex, int ey, FB_pixel color);

int FB_getVisual();
void FB_getres(int *x, int *y);
int FB_getXVres();
int FB_getYVres();
int FB_getbpp();
int FB_setbpp(int bpp);
#endif

